=== debian/changelog ===
pgrouting (2.0.0-3) unstable; urgency=low

  * Build for multiple PostgreSQL versions (Closes: #757786).
    + Use pg_buildext where possible.
    + Call cmake with custom path that all include the PostgreSQL version.
    + Build documentation and replace duplicate files with symlinks.
    + Install lintian override for call to exit() in plugin code, only used in
      a helper method.
  * Install upstream changelog.
  * Add lintian override for missing upstream GPG signature.
  * Use emtpy override_dh_sphinxdoc-arch to prevent dh_sphinxdoc from running
    in binary-arch.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Mon, 18 Aug 2014 12:10:01 +0200

pgrouting (2.0.0-2) unstable; urgency=low

  * Omit "--with sphinxdoc" when building binary-arch.

 -- Michael Fladischer <FladischerMichael@fladi.at>  Mon, 28 Oct 2013 09:08:23 +0100

pgrouting (2.0.0-1) unstable; urgency=low

  * Initial release (Closes: #714831).

 -- Michael Fladischer <FladischerMichael@fladi.at>  Thu, 03 Oct 2013 10:55:42 +0200
