=== debian/control ===
Source: pgrouting
Section: misc
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <FladischerMichael@fladi.at>
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-graph-dev,
               libcgal-dev,
               postgresql-server-dev-all,
               python-sphinx (>= 1.0.7+dfsg)
Standards-Version: 3.9.5
Homepage: http://www.pgrouting.org
Vcs-Git: git://anonscm.debian.org/pkg-grass/pgrouting.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-grass/pgrouting.git

Package: postgresql-9.4-pgrouting
Architecture: any
Depends: postgresql-9.4,
         postgresql-9.4-postgis-2.1,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.4-pgrouting-doc
Description: basic routing functionality support for PostgreSQL 9.4
 pgRouting is part of PostLBS, which provides core tools for Location Based
 Services (LBS). It adds support for some routing algorithm to the PostgreSQL
 object-relational database and it's core includes three types of shortest path
 implementation. In combination with PostGIS this extension provides more useful
 functionality.

Package: postgresql-9.4-pgrouting-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: basic routing functionality support for PostgreSQL 9.4 (Documentation)
 pgRouting is part of PostLBS, which provides core tools for Location Based
 Services (LBS). It adds support for some routing algorithm to the PostgreSQL
 object-relational database and it's core includes three types of shortest path
 implementation. In combination with PostGIS this extension provides more useful
 functionality.
 .
 This package contains the documentation.
