=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/pgrouting-$1.tar.gz/ \
https://github.com/pgRouting/pgrouting/releases \
/pgRouting/pgrouting/archive/v([\d.]+(?:-rc\d+)?)\.tar\.gz
