=== src/shooting_star/CMakeLists.txt ===
SET(PACKAGE_SQL_FILES "")
ADD_SUBDIRECTORY(sql)
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)
#MESSAGE("core/shooting_star: ${PACKAGE_SQL_FILES}")
SUBDIRS(doc src test)
