=== debian/changelog ===
pgrouting (2.1.0-1) unstable; urgency=medium

  * Team upload.
  * Update watch file to detect 2.1.x releases.
  * New upstream release.
  * Update copyright file, changes:
    - Group copyright holders by license
    - Simplify glob patterns for CC-BY-SA-3.0 licensed documentation
    - Add license & copyright for new files
  * Override dh_install to use --list-missing.
  * Don't symlink before_node_net1.png, no longer included.
  * Use libjs-mathjax instead of online version.
  * Override dh_makeshlibs to exclude usr/lib/postgresql,
    prevents postinst-has-useless-call-to-ldconfig.
  * Drop unused lintian override for shlib-calls-exit.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 05 Feb 2016 12:55:23 +0100

pgrouting (2.0.0-5) unstable; urgency=medium

  * Team upload.
  * Rename packages for PostgreSQL 9.5.
  * Use BSL-1.0 SPDX license shortname instead of Boost-1.0.
  * Fix 'manual' typo in doc-base Title.
  * Update watch file, changes:
    - Add common dversionmangle
    - Handle other tar extensions

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 08 Jan 2016 15:59:39 +0100

pgrouting (2.0.0-4) unstable; urgency=medium

  * Team upload.
  * Update PostGIS dependency for 2.2.
  * Update Vcs-Browser URL to use cgit over HTTPS.
  * Restructure control file with cme, changes:
    - Bump Standards-Version to 3.9.6, no changes.
  * Enable parallel builds.
  * Add non-template control file for git-buildpackage builds.
  * Add gbp.conf to use pristine-tar by default.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 10 Dec 2015 09:49:37 +0100
