=== debian/control ===
Source: pgrouting
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <FladischerMichael@fladi.at>
Section: misc
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-graph-dev,
               libcgal-dev,
               libjs-mathjax,
               postgresql-server-dev-all,
               python-sphinx (>= 1.0.7+dfsg)
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pgrouting.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pgrouting.git
Homepage: http://www.pgrouting.org

Package: postgresql-9.5-pgrouting
Architecture: any
Depends: postgresql-9.5,
         postgresql-9.5-postgis-2.2,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.5-pgrouting-doc
Description: basic routing functionality support for PostgreSQL 9.5
 pgRouting is part of PostLBS, which provides core tools for Location Based
 Services (LBS). It adds support for some routing algorithm to the PostgreSQL
 object-relational database and it's core includes three types of shortest path
 implementation. In combination with PostGIS this extension provides more useful
 functionality.

Package: postgresql-9.5-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: basic routing functionality support for PostgreSQL 9.5 (Documentation)
 pgRouting is part of PostLBS, which provides core tools for Location Based
 Services (LBS). It adds support for some routing algorithm to the PostgreSQL
 object-relational database and it's core includes three types of shortest path
 implementation. In combination with PostGIS this extension provides more useful
 functionality.
 .
 This package contains the documentation.
