=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 include /usr/share/postgresql-common/pgxs_debian_control.mk
 
 %:
-	dh $@ --with sphinxdoc
+	dh $@ --with sphinxdoc --parallel
 
 override_dh_auto_configure:
 	set -e; \
@@ -23,8 +23,7 @@
 		ln -s ../pgrouting.png build-$$v/doc/html/en/_static/images/pgrouting.png; \
 		rm build-$$v/doc/html/en/_static/images/ccbysa.png; \
 		ln -s ../../_images/ccbysa.png build-$$v/doc/html/en/_static/images/ccbysa.png; \
-		rm build-$$v/doc/html/en/_images/before_node_net1.png; \
-		ln -s before_node_net.png build-$$v/doc/html/en/_images/before_node_net1.png; \
+		ln -s /usr/share/javascript/mathjax build-$$v/doc/html/en/_static/mathjax; \
 	done
 
 override_dh_auto_install:
@@ -45,13 +44,12 @@
 
 override_dh_sphinxdoc-arch:
 
+override_dh_install:
+	dh_install --list-missing
+
 override_dh_installchangelogs:
-	dh_installchangelogs doc/src/changelog/2_0.rst
+	dh_installchangelogs doc/src/changelog/2_1_0.rst
 
-override_dh_lintian:
-	set -e; \
-	for v in $$(pg_buildext supported-versions); do \
-		mkdir -p debian/postgresql-$$v-pgrouting/usr/share/lintian/overrides; \
-		sed "s,PGVERSION,$$v,g" <debian/postgresql-pgrouting.lintian-overrides.in >debian/postgresql-$$v-pgrouting/usr/share/lintian/overrides/postgresql-$$v-pgrouting; \
-	done
-	dh_lintian
+override_dh_makeshlibs:
+	dh_makeshlibs -Xusr/lib/postgresql
+
